\section{Local Optimization}

\subsection{QoraTom}
\subsubsection{Workflow}
\begin{frame}{QoraTom – Workflow}
	\begin{figure}
		\centering
		\resizebox{\textwidth}{!}{\input{img/qoratom-workflow}}
		\caption{From QoS contract polytopes to MiniZinc/MiniBrass}
	\end{figure}
\end{frame}

\subsubsection{Example}
\begin{frame}[fragile]{QoraTom – Example – Input}
	\begin{lstlisting}[language=qos2mzn, gobble=4, basicstyle=\small\ttfamily, caption={Sample QoraTom input (slightly simplified)}]
		array [1..2] of 0.0..1.0: ranks = ContractRanks {
			provisions: [
				1 ≤ cost ≤ 3 /\ 1 ≤ latency ≤ 3,
				2 ≤ cost + latency ≤ 4 /\ cost ≤ latency + 2 /\ 2 + cost ≥ latency];
			requirement: 0 ≤ cost ≤ 2 /\ 0 ≤ latency ≤ 2;
		};

		var 1..2: selected_provision;
		solve maximize ranks[selected_provision];
	\end{lstlisting}
\end{frame}

\begin{frame}[fragile]{QoraTom – Example – Output}
	\begin{lstlisting}[language=qos2mzn, gobble=4, basicstyle=\small\ttfamily, caption={Sample QoraTom output (slightly simplified)}]
		array [1..2] of 0.0..1.0: ranks =
			[ 0.24887225778644162,
			  0.5043493969555476 ]; @\vspace{5\baselineskip}@
		var 1..2: selected_provision;
		solve maximize ranks[selected_provision];
	\end{lstlisting}
\end{frame}

\subsection{Requirements of Hanoi}
\begin{frame}{Requirements of Hanoi}
	\begin{figure}
		\source{\href{https://commons.wikimedia.org/wiki/File:Tower_of_Hanoi.jpeg}{Tower\_of\_Hanoi.jpeg on Wikimedia Commons}~(\href{https://creativecommons.org/licenses/by-sa/3.0/deed.en}{CC BY-SA 3.0})}
		\resizebox{\textwidth}{!}{\input{img/hanoi}}
		\caption{Towers of Hanoi}
	\end{figure}
\end{frame}